unit proced;

interface

uses
  Windows,SysUtils,Graphics,Classes,dialogs,wave, DirectXgraphics,PowerDraw3, dib,
  Messages, Controls, Forms,math, agfunit, PowerFonts, PowerTiming, powertypes;

type
Image = record
Width,Height:integer;
Picture:TagfImage;
name:string;
end;

  function chinar(val:integer;x1,x2:integer):boolean;
  function rinr(r:Trect;r2:Trect):boolean;
  function chvarr(x,val1,val2:integer):integer;
  procedure printscreen(form:TForm);
  procedure ImDraw(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,effect:integer);
  procedure ImFlipDraw(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,effect:integer);
  procedure ImStrDraw(pd:TPowerDraw;name:Tagfimage;x,y,width,height,patternnumber,effect:integer); overload;
  procedure ImStrDraw(pd:TPowerDraw;name:Tagfimage;x,y,width,height,patternnumber,alpha:integer;ifisalpha:boolean); overload;
  Procedure Dnt(pf:TpowerFont;text:string;x,y,color,center:integer);
  procedure ImRtDraw(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,angle,effect:integer);
  procedure ImDrawSh(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,angle,alpha:integer);
  procedure ImDrawAlpha(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,alpha:integer);
  function FindImage(name:string):TagfImage;
  procedure LoadGrafix(pd:TPowerDraw;name:string); overload;
var
I:integer;
alreadyin:integer=0;
Il: Array of Image;
implementation

uses unit1;

procedure ImDrawSh(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,angle,alpha:integer);
begin
pd.RotateEffect(name,x+name.PatternWidth div 2,y+name.PatternHeight div 2,angle*256 div 360,256,(alpha shl 24),patternnumber,effectInvMultiply);
end;

procedure ImDrawAlpha(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,alpha:integer);
begin
pd.RenderEffectCol(name,x,y,256,(alpha shl 24) or $FFFFFF,patternnumber,effectSrcAlpha or effectDiffuse);
end;

procedure LoadGrafix(pd:TPowerDraw;name:string);
Var Res: Integer;
FResult       : integer;
SR     : TSearchRec;
s:TstringList;
begin
FResult:=FindFirst(extractfilepath(application.ExeName)+name+'\*.bmp',faArchive,SR);
While FResult=0 do begin
s:=TstringList.Create;
if fileexists(name+'\'+changefileext(sr.Name,'.txt')) then s.LoadFromFile(name+'\'+changefileext(sr.Name,'.txt')) else
if fileexists(name+'\all.txt')then s.LoadFromFile(name+'\all.txt');
begin
inc(alreadyin);
setlength(il,alreadyin);
il[alreadyin-1].Picture:=TAgfImage.Create(pd);
il[alreadyin-1].name:=changefileext(sr.Name,'');
Res:=il[alreadyin-1].Picture.LoadFromFile(name+'\'+sr.Name,strtoint(s[0]),strtoint(s[1]),strtoint(s[2]),strtoint(s[3]),D3DFMT_A1R5G5B5);
 if (Res <> 0) then
  begin
   MessageDlg(ErrorString(Res), mtError, [mbOk], 0);
   Application.Terminate();
   Exit;
  end else
il[alreadyin-1].Picture.TransparentColor:=(stringtocolor(s[4]));
s.Free;
end;
FResult:=FindNext(Sr);
end;
Sysutils.FindClose(Sr);
end;


function FindImage(name:string):TagfImage;
var i:integer;
begin
result:=nil;
for i:=0 to alreadyin do
if lowercase(il[i].name)=lowercase(name) then
result:=il[i].Picture;
end;

Procedure Dnt(pf:TpowerFont;text:string;x,y,color,center:integer);
begin
if center=1 then
pf.textout(text,x-pf.textwidth(text)div 2,y,color)
else
pf.textout(text,x,y,color);
end;

procedure ImDraw(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,effect:integer);
begin
pd.RenderEffect(name,x,y,patternnumber,effect);
end;

procedure ImFlipDraw(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,effect:integer);
var C:tcolor;
begin
c:=(255 shl 24) or $FFFFFF;
pd.TextureMap(name, pMirror4(pBounds4(x, y, name.PatternWidth, name.PatternHeight)),
cColor1(c), tPattern(patternnumber), effectSrcAlpha or effectDiffuse);
end;

procedure ImStrDraw(pd:TPowerDraw;name:Tagfimage;x,y,width,height,patternnumber,effect:integer);
begin
pd.RenderEffect(name,bounds(x,y,width,height),patternnumber,effect);
end;

procedure ImStrDraw(pd:TPowerDraw;name:Tagfimage;x,y,width,height,patternnumber,alpha:integer;ifisalpha:boolean);
begin
pd.RenderEffectCol(name,bounds(x,y,width,height),(alpha shl 24) or $FFFFFF,patternnumber, effectSrcAlpha or effectDiffuse);
end;


procedure ImRtDraw(pd:TPowerDraw;name:Tagfimage;x,y,patternnumber,angle,effect:integer);
begin
pd.RotateEffect(name,x,y,angle*256 div 360,1,patternnumber,effect);
end;

function chvarr(x,val1,val2:integer):integer;
begin
if x<min(val1,val2) then
begin
result:=max(val1,val2)-(x mod max(val1,val2))-1;
exit;
end else
if x>max(val1,val2) then
begin
result:=min(val1,val2)+(x mod max(val1,val2))-1;
exit;
end else
result:=x;
end;

function chinar(val:integer;x1,x2:integer):boolean;
begin
result:=((val>=min(x1,x2))and(val<=max(x1,x2)));
end;

procedure printscreen(form:TForm);
var D:Tdib;
begin
d:=tdib.Create;
d.SetSize(800,600,24);
bitblt(d.Canvas.Handle,0,0,800,600,form.Canvas.Handle,0,0,srccopy);
while fileexists('screen'+inttostr(i)+'.bmp')do
inc(i);
d.SaveToFile('screen'+inttostr(i)+'.bmp');
end;

function rinr(r:Trect;r2:Trect):boolean;
begin
if(R.Left < R2.Right) and
  (R.Right > R2.Left) and
  (R.Top < R2.Bottom) and
  (R.Bottom > R2.Top) or
  (R2.Left < R.Right) and
  (R2.Right > R.Left) and
  (R2.Top < R.Bottom) and
  (R2.Bottom > R.Top) then
Result := true else
result:=false;
end;



begin
end.
